OpenShot Audio Library | OpenShotAudio: juce::ErasedScopeGuard Class Reference

OpenShot Audio Library | OpenShotAudio 1.0.0

Loading...
Searching...
No Matches
juce::ErasedScopeGuard Class Reference

`#include <juce_ScopeGuard.h>`

## Public Member Functions
| ErasedScopeGuard ()=default
| ErasedScopeGuard (std::function< void()> d)
| ErasedScopeGuard (ErasedScopeGuard &&other) noexcept
ErasedScopeGuard & | operator= (ErasedScopeGuard &&other) noexcept
| ~ErasedScopeGuard () noexcept
void | reset ()
void | release ()

## Detailed Description

A ScopeGuard that uses a std::function internally to allow type erasure. This can be handy; it allows lots of ErasedScopeGuards, all with different callbacks, to be stored in a homogeneous container.

An instance of this type will automatically call its callback when it is destroyed.

ErasedScopeGuard has a few similarities with std::unique_ptr:

- Calling reset() on a unique_ptr destroys the object if it hasn't been destroyed yet and puts the unique_ptr back into a default/null state; calling reset() on an ErasedScopeGuard calls the callback if it hasn't been called yet and puts the Guard back into a default/null state.
- Calling release() on a unique_ptr returns the unique_ptr back to a default state without destroying the managed object; calling release() on an ErasedScopeGuard returns the Guard back to a default state without calling the callback.
- Moving a unique_ptr transfers the responsibility of destroying the managed object to another unique_ptr instance; moving an ErasedScopeGuard transfers the responsibility of calling the callback to another Guard instance.

Definition at line 76 of file juce_ScopeGuard.h.

## Constructor & Destructor Documentation

## ◆ ErasedScopeGuard() [1/3]

juce::ErasedScopeGuard::ErasedScopeGuard | ( |  | ) |
| default

Constructs an ErasedScopeGuard with no callback.

Referenced by ErasedScopeGuard(), ErasedScopeGuard(), and operator=().

## ◆ ErasedScopeGuard() [2/3]

juce::ErasedScopeGuard::ErasedScopeGuard | ( | std::function< void()> | d | ) |
| explicit

Constructs an ErasedScopeGuard that will call the provided callback when the Guard is destroyed.

Definition at line 26 of file juce_ScopeGuard.cpp.

## ◆ ErasedScopeGuard() [3/3]

juce::ErasedScopeGuard::ErasedScopeGuard | ( | ErasedScopeGuard && | other | ) |
| noexcept

Constructs an instance that assumes responsibility for calling other's callback.

Definition at line 29 of file juce_ScopeGuard.cpp.

## ◆ ~ErasedScopeGuard()

juce::ErasedScopeGuard::~ErasedScopeGuard | ( |  | ) |
| noexcept

Destructor, calls the callback assigned to this ScopeGuard.

Definition at line 39 of file juce_ScopeGuard.cpp.

## Member Function Documentation

## ◆ operator=()

ErasedScopeGuard & juce::ErasedScopeGuard::operator= | ( | ErasedScopeGuard && | other | ) |
| noexcept

Calls the stored callback, if any, then assumes responsibility for calling other's callback. After this call, other will be reset to its default state.

Definition at line 32 of file juce_ScopeGuard.cpp.

## ◆ release()

void juce::ErasedScopeGuard::release | ( |  | ) |

Resets this instance to its default state without calling the stored callback.

Definition at line 50 of file juce_ScopeGuard.cpp.

Referenced by ErasedScopeGuard().

## ◆ reset()

void juce::ErasedScopeGuard::reset | ( |  | ) |

Calls the stored callback, if any, then resets this instance to its default state.

Definition at line 44 of file juce_ScopeGuard.cpp.

Referenced by ErasedScopeGuard(), and ~ErasedScopeGuard().

The documentation for this class was generated from the following files:

- juce_ScopeGuard.h
- juce_ScopeGuard.cpp